/*********************************************************************************
*
*               SHARP MZ-80B/80B2/2000/2200 Emulator for Win32
*
*                        EmuZ-2000  Extend Board DLL
*
*                               << EmuZ-1M11 >>
*
*                          Main Module [emuz_1m11.c]
*
*               Programmed by 2017-1 Takky
*
*********************************************************************************/
//
//
// Visual Studiǒx
#define _CRT_SECURE_NO_WARNINGS 1

#include <windows.h>
#include <commdlg.h>
#include <shellapi.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <string.h>
//#include <alloc.h>
#include <errno.h>
#include <ctype.h>
//#include <dir.h>

#include "resource.h"
#include "..\interface\emuz2000ioBoard.h"
//Support Debugger
//#include "..\interface\emuz2000debug.h"
#include "..\interface\plugin_ex.h"
#include "emuz_1m11.h"

////////////////////////////////////
// Prototype 
////////////////////////////////////
UCHAR InportFunction(USHORT);
int OutportFunction(USHORT, UCHAR);

////////////////////////////////////
// Global Variable 
////////////////////////////////////
#define	TITLE_LINE	"EmuZ-2000GRAM-BMPϊc["
HINSTANCE		h_instdll = NULL ;
static char *cpGram1 = NULL;
static char *cpGram2 = NULL;
static char *cpGram3 = NULL;

EMUZ2000EBIH	emuz_1m11EBIH = {
	"139E98D1-A3C0-4203-9D48-A29B105F8C84",
	"EmuZ-1M11 GRAM-BMP Converter",
	"EmuZ-1M11 Version " EmuZ1M11_VERSION,
	"Copyright 2017-1 by Takky",
	"http://mio.servequake.com/~takky/emuz2000/",
	"takky386@gmail.com",
	0x00000000,	//Reserved
	InportFunction,
	OutportFunction,
	0x80,
	0x00,
	USE_INFODIALOG | USE_MAINMEMORY
} ;

DWORD	gId = 0 ;
DWORD	dwBase = 0x80 ;

/* pbgf[^ */
static RGBQUAD pal[16] = {		/* screen_crtc.c pbg𒸂 */
	{   1,  1,  2,  0 },		/* 0:BLACK */
	{ 253,  1,  1,  0 },		/* 1:BLUE */
	{   1,  1,253,  0 },		/* 2:RED */
	{ 253,  1,253,  0 },		/* 3:PURPLE */
	{   1,253,  1,  0 },		/* 4:GREEN */
	{ 253,254,  1,  0 },		/* 5:CYAN */
	{   1,253,254,  0 },		/* 6:YELLOW */
	{ 253,253,253,  0 },		/* 7:WHITE */
	{ 253,253,253,  0 },		/* 8:TEXT Color */
	{ 253,  1,  1,  0 },		/* 9:BLUE */
	{   1,  1,253,  0 },		/* 10:RED */
	{ 253,  1,253,  0 },		/* 11:PURPLE */
	{   1,253,  1,  0 },		/* 12:GREEN */
	{ 253,254,  1,  0 },		/* 13:CYAN */
	{   1,253,254,  0 },		/* 14:YELLOW */
	{ 253,253,253,  0 }			/* 15:WHITE */
};

//////////////////////////////////////////////////////////////////////////////////////
// Logic Start

// GRAMBMP֕ϊ
void OutputBMP(HWND hWnd, char *FileName, int res)
{
HANDLE hFile;
DWORD outlen;
BITMAPFILEHEADER hd1;
BITMAPINFOHEADER hd2;
char	plain[64000];		// Canvas data 640x200 / 2 = 64000
int	i, x, y, p1, p2, p3, p4, p5, p6, p7, p8;
int	pX, nByte1, nByte2, nByte3;
char	szString[512];

	if (res == 0)
		pX = 320;
	else
		pX = 640;

	/** BMPwb_̍쐬 **/
	hd1.bfType = 19778;			/* "BM" */
	hd1.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)
		+ sizeof(RGBQUAD)*16 + pX * 200;
	hd1.bfReserved1 = 0;		/* 0ŃU[u */
	hd1.bfReserved2 = 0;		/* 0ŃU[u */
	hd1.bfOffBits = 0x076;		/* 16BMPł͂̒lŒl */
	hd2.biSize = 0x28;			/*          "               */
	hd2.biWidth = pX;			/* 摜f[^ 328x200 or */
	hd2.biHeight = 200;			/*            640x200 */
	hd2.biPlanes = 1;			/* 1 Œ */
	hd2.biBitCount = 4;			/* 16BMP */
	hd2.biCompression = 0;		/* k 0 */
	hd2.biSizeImage = pX * 200;
	hd2.biXPelsPerMeter = 0;
	hd2.biYPelsPerMeter = 0;
	hd2.biClrUsed= 0;			/* 0 ͑Sgp */
	hd2.biClrImportant = 8;	/* F̐ */

	/** 摜f[^ **/
	/** GRAM͍ォEA֌ăjAɊi[Ă **/
	/** 320x200[hłQrbgłPrbg
	    640x200[h1rbg1rbg */
	/* BMP͍EAɌăpbgԍSrbgŊi[Ă */
	/* GRAM1`3y[WPoCgĂāA8rbg܂4rbgB
	   ꂼ̃rbg̐FiGRAM1`3ON/OFFł̏d݁jZopbgԍƂB
	   pbgԍ4rbgÂi[B */
	i=0;
	for (y=199; y>=0; y--) {
		for (x=0; x<80; x++) {
			nByte1 = *(cpGram1+y*80+x);
			nByte2 = *(cpGram2+y*80+x);
			nByte3 = *(cpGram3+y*80+x);
			if (res == 1) {
				p1 = (0x0001 & nByte1)+(0x0001 & nByte2)*2+(0x0001 & nByte3)*4;
				p2 = ((0x0002 & nByte1)>>1)+((0x0002 & nByte2)>>1)*2+((0x0002 & nByte3)>>1)*4;
				p3 = ((0x0004 & nByte1)>>2)+((0x0004 & nByte2)>>2)*2+((0x0004 & nByte3)>>2)*4;
				p4 = ((0x0008 & nByte1)>>3)+((0x0008 & nByte2)>>3)*2+((0x0008 & nByte3)>>3)*4;
				p5 = ((0x0010 & nByte1)>>4)+((0x0010 & nByte2)>>4)*2+((0x0010 & nByte3)>>4)*4;
				p6 = ((0x0020 & nByte1)>>5)+((0x0020 & nByte2)>>5)*2+((0x0020 & nByte3)>>5)*4;
				p7 = ((0x0040 & nByte1)>>6)+((0x0040 & nByte2)>>6)*2+((0x0040 & nByte3)>>6)*4;
				p8 = ((0x0080 & nByte1)>>7)+((0x0080 & nByte2)>>7)*2+((0x0080 & nByte3)>>7)*4;
				plain[i]   = (char)(0x00ff & (((0x00ff & p1) << 4) + (0x00ff & p2)));
				plain[i+1] = (char)(0x00ff & (((0x00ff & p3) << 4) + (0x00ff & p4)));
				plain[i+2] = (char)(0x00ff & (((0x00ff & p5) << 4) + (0x00ff & p6)));
				plain[i+3] = (char)(0x00ff & (((0x00ff & p7) << 4) + (0x00ff & p8)));
				i += 4;
			} else {
				p1 = (0x0001 & nByte1)+(0x0001 & nByte2)*2+(0x0001 & nByte3)*4;
				p2 = ((0x0008 & nByte1)>>3)+((0x0008 & nByte2)>>3)*2+((0x0008 & nByte3)>>3)*4;
				p3 = ((0x0010 & nByte1)>>4)+((0x0010 & nByte2)>>4)*2+((0x0010 & nByte3)>>4)*4;
				p4 = ((0x0080 & nByte1)>>7)+((0x0080 & nByte2)>>7)*2+((0x0080 & nByte3)>>7)*4;
				plain[i]   = (char)(0x00ff & (((0x00ff & p1) << 4) + (0x00ff & p2)));
				plain[i+1] = (char)(0x00ff & (((0x00ff & p3) << 4) + (0x00ff & p4)));
				i += 2;
			}
		}
	}

	snprintf(szString, sizeof(szString), "GRAM̓e %s ֓WJ܂B\ns܂H", FileName);
	if (MessageBox(NULL, szString, TITLE_LINE, MB_OKCANCEL | MB_ICONQUESTION) == IDCANCEL)
		return;

	/* alot@C̏o */
	// t@CΊmF_CAOoB
	if (GetFileAttributes(FileName) != -1) {
		snprintf(szString, sizeof(szString), "%s ͊ɑ݂܂B\n㏑܂H", FileName);
		if (MessageBox(NULL, szString, TITLE_LINE, MB_OKCANCEL | MB_ICONQUESTION) == IDCANCEL)
			return;
		DeleteFile(FileName);
	}
	if ((hFile = CreateFile(FileName, GENERIC_WRITE, 0,
		NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		MessageBox(NULL, "BMPt@C쐬ł܂BgpAANZXȂǂ̊mFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	/* FILEHEADER */
	WriteFile(hFile, (char *)&hd1, sizeof(BITMAPFILEHEADER), &outlen, NULL);
	/* INFOHEADER */
	WriteFile(hFile, (char *)&hd2, sizeof(BITMAPINFOHEADER), &outlen, NULL);
	/* PALETTE */
	WriteFile(hFile, (char *)&pal[0], sizeof(RGBQUAD)*16, &outlen, NULL);
	/* CANVAS */
	WriteFile(hFile, &plain[0], (pX * 200/2), &outlen, NULL);
	CloseHandle(hFile);
	MessageBox(NULL, "BMPt@Cւ̏݊", TITLE_LINE, MB_OK | MB_ICONINFORMATION);
}

// BMPGRAM֕ϊ
void ReadBMP(HWND hWnd, char *FileName, int res)
{
HANDLE hFile;
DWORD readlen;
BITMAPFILEHEADER hd1;
BITMAPINFOHEADER hd2;
RGBQUAD pal0[16];
char	plain[64000];		// Canvas data 640x200 / 2 = 64000
int	i, x, y, p1, p2, p3, p4, p5, p6, p7, p8;
int	pX, nByte1, nByte2, nByte3;
char	szString[512];

	memset(szString, 0x00, 512);
	if ((hFile = CreateFile(FileName, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		snprintf(szString, sizeof(szString),
			"%s I[vł܂BgpAANZXȂǂ̊mFĂB", FileName);
		MessageBox(NULL, szString, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if (res == 0)
		pX = 320;
	else
		pX = 640;

	ReadFile(hFile, (char *)&hd1, sizeof(BITMAPFILEHEADER), &readlen, NULL);
	if (readlen != sizeof(BITMAPFILEHEADER) || hd1.bfType != 19778) {
		MessageBox(NULL, "BMPt@Cł͂Ȃ悤łBt@CemFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	ReadFile(hFile, (char *)&hd2, sizeof(BITMAPINFOHEADER), &readlen, NULL);
	if (readlen != sizeof(BITMAPINFOHEADER)) {
		MessageBox(NULL, "BMPt@Cł͂Ȃ悤łBBITMAPINFOHEADER݂܂Bt@CemFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if (hd2.biBitCount != 4) {
		MessageBox(NULL, "16FBMPt@CȊO̓T|[gĂ܂B16FBMP֕ϊĂw肵ĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if (hd2.biWidth != pX || hd2.biHeight != 200) {
		snprintf(szString, sizeof(szString), "LoXTCY %d X 200 ō쐬ĂB", pX);
		MessageBox(NULL, szString, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	ReadFile(hFile, (char *)&pal0[0], sizeof(RGBQUAD)*16, &readlen, NULL);
	if (readlen != sizeof(RGBQUAD)*16) {
		MessageBox(NULL, "BMPt@Cł͂Ȃ悤łBRGBQUADf[^mɓǂ߂܂Bt@CemFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	ReadFile(hFile, &plain[0], (pX * 200/2), &readlen, NULL);
	if (readlen != (pX * 200/2)) {
		MessageBox(NULL, "BMPt@Cł͂Ȃ悤łB摜f[^mɓǂ߂܂Bt@CemFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	CloseHandle(hFile);

	snprintf(szString, sizeof(szString), "%s ̓eGRAM֓WJ܂B\ns܂H", FileName);
	if (MessageBox(NULL, szString, TITLE_LINE, MB_OKCANCEL | MB_ICONQUESTION) == IDCANCEL)
		return;

	/** 摜f[^ **/
	/* BMP͍EAɌăpbgԍSrbgŊi[ĂB */
	/** GRAM͍ォEA֌ăjAɊi[Ă **/
	/** 320x200[hłQrbgłPrbg
	    640x200[h1rbg1rbg */
	/*  BMP̃LoXf[^4rbg1rbg܂2rbgƂďB
	    1rbg̃pbgԍBRG3rbg̏d݂ƂĈAGRAM֏
	    f[^쐬ď */
	i=0;
	for (y=199; y>=0; y--) {
		for (x=0; x<80; x++) {
			if (res == 1) {
				p1 = plain[i]>>4   & 0x000f;
				p2 = plain[i]      & 0x000f;
				p3 = plain[i+1]>>4 & 0x000f;
				p4 = plain[i+1]    & 0x000f;
				p5 = plain[i+2]>>4 & 0x000f;
				p6 = plain[i+2]    & 0x000f;
				p7 = plain[i+3]>>4 & 0x000f;
				p8 = plain[i+3]    & 0x000f;
				nByte1 = 0;
				nByte2 = 0;
				nByte3 = 0;
				if (p1 & 0x0001)
					nByte1 += 0x0001;
				if (p1 & 0x0002)
					nByte2 += 0x0001;
				if (p1 & 0x0004)
					nByte3 += 0x0001;
				if (p2 & 0x0001)
					nByte1 += 0x0002;
				if (p2 & 0x0002)
					nByte2 += 0x0002;
				if (p2 & 0x0004)
					nByte3 += 0x0002;
				if (p3 & 0x0001)
					nByte1 += 0x0004;
				if (p3 & 0x0002)
					nByte2 += 0x0004;
				if (p3 & 0x0004)
					nByte3 += 0x0004;
				if (p4 & 0x0001)
					nByte1 += 0x0008;
				if (p4 & 0x0002)
					nByte2 += 0x0008;
				if (p4 & 0x0004)
					nByte3 += 0x0008;
				if (p5 & 0x0001)
					nByte1 += 0x0010;
				if (p5 & 0x0002)
					nByte2 += 0x0010;
				if (p5 & 0x0004)
					nByte3 += 0x0010;
				if (p6 & 0x0001)
					nByte1 += 0x0020;
				if (p6 & 0x0002)
					nByte2 += 0x0020;
				if (p6 & 0x0004)
					nByte3 += 0x0020;
				if (p7 & 0x0001)
					nByte1 += 0x0040;
				if (p7 & 0x0002)
					nByte2 += 0x0040;
				if (p7 & 0x0004)
					nByte3 += 0x0040;
				if (p8 & 0x0001)
					nByte1 += 0x0080;
				if (p8 & 0x0002)
					nByte2 += 0x0080;
				if (p8 & 0x0004)
					nByte3 += 0x0080;
				*(cpGram1+y*80+x) = nByte1;
				*(cpGram2+y*80+x) = nByte2;
				*(cpGram3+y*80+x) = nByte3;
				i += 4;
			} else {
				p1 = plain[i]>>4   & 0x000f;
				p2 = plain[i]      & 0x000f;
				p3 = plain[i+1]>>4 & 0x000f;
				p4 = plain[i+1]    & 0x000f;
				nByte1 = 0;
				nByte2 = 0;
				nByte3 = 0;
				if (p1 & 0x0001)
					nByte1 += 0x0003;
				if (p1 & 0x0002)
					nByte2 += 0x0003;
				if (p1 & 0x0004)
					nByte3 += 0x0003;
				if (p2 & 0x0001)
					nByte1 += 0x000c;
				if (p2 & 0x0002)
					nByte2 += 0x000c;
				if (p2 & 0x0004)
					nByte3 += 0x000c;
				if (p3 & 0x0001)
					nByte1 += 0x0030;
				if (p3 & 0x0002)
					nByte2 += 0x0030;
				if (p3 & 0x0004)
					nByte3 += 0x0030;
				if (p4 & 0x0001)
					nByte1 += 0x00c0;
				if (p4 & 0x0002)
					nByte2 += 0x00c0;
				if (p4 & 0x0004)
					nByte3 += 0x00c0;
				*(cpGram1+y*80+x) = nByte1;
				*(cpGram2+y*80+x) = nByte2;
				*(cpGram3+y*80+x) = nByte3;
				i += 2;
			}
		}
	}
	MessageBox(NULL, "GRAMւ̏݊", TITLE_LINE, MB_OK | MB_ICONINFORMATION);
}

///////////////////////////////////////////////////////
// System interface
///////////////////////////////////////////////////////
BOOL WINAPI
DllMain(
	HINSTANCE	inst,
	DWORD		q_mode,
	LPVOID		vp_res_c )
{
	switch (q_mode) {
	case DLL_PROCESS_ATTACH :
		h_instdll = inst;
		break;
	case DLL_THREAD_ATTACH :
		break;
	case DLL_THREAD_DETACH :
		break;
	case DLL_PROCESS_DETACH :
		h_instdll = NULL;
		break;
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////
// EmuZ-2000 Interface
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Dialog Callback
/////////////////////////////////////////////////////////////////////
/** AboutBox_CAO{ OK{^ꂽIBȊO͉Ȃ **/
BOOL WINAPI
About(
	HWND hDlg,
	UINT message,
	WPARAM wParam,
	LPARAM lParam)
{
	switch (message) {
		/** ڑĨbZ[W **/
		case WM_COMMAND:
			if (wParam == IDOK) {
				EndDialog(hDlg, TRUE);
				return (FALSE);
			}
			break;

		default:
			return(FALSE);
    }
	return (TRUE);
}

BOOL WINAPI
InfomationDlgProc(
	HWND hWnd,
	UINT message,
	WPARAM wParam,
	LPARAM lParam)
{
static char szBMPFileName[MAX_PATH];
static char szDropFileName[MAX_PATH];
static int	bType = 0;
static int	bRes = 0;
OPENFILENAME	OFN;
char	Filter[256], szCurDir[MAX_PATH];
int	sPos;
POINT ptDrop;

	switch (message) {
/** _CAȌ **/
		case WM_INITDIALOG:
			DragAcceptFiles(hWnd, TRUE);
			memset(szBMPFileName, 0x00, sizeof(szBMPFileName));
			if (bType == 0)
				CheckRadioButton(hWnd, IDC_RADIOBUTTON1, IDC_RADIOBUTTON2,
					IDC_RADIOBUTTON1);
			else
				CheckRadioButton(hWnd, IDC_RADIOBUTTON1, IDC_RADIOBUTTON2,
					IDC_RADIOBUTTON2);
			if (bRes == 0)
				CheckRadioButton(hWnd, IDC_RADIOBUTTON3, IDC_RADIOBUTTON4,
					IDC_RADIOBUTTON3);
			else
				CheckRadioButton(hWnd, IDC_RADIOBUTTON3, IDC_RADIOBUTTON4,
					IDC_RADIOBUTTON4);
			break;

/** t@C̃hbv **/
		case WM_DROPFILES:
			/* hbvꂽt@C1ڂ̗pă_CAO֏o */
			DragQueryPoint((HDROP)wParam, &ptDrop);
			DragQueryFile((HDROP)wParam, 0, szDropFileName, MAX_PATH);
			DragFinish((HDROP)wParam);
			SetDlgItemText(hWnd, IDC_EDIT1, szDropFileName);
			strcpy(szBMPFileName, szDropFileName);
			InvalidateRect(hWnd, NULL, TRUE);
			break;

		// {^ñR}h
		case WM_COMMAND:
			switch(wParam) {
				case IDC_BUTTON1:	// _vt@CQ
					/* J_CAOoăt@CIĂ炤 */
					memset(szCurDir, 0x00, sizeof(szCurDir));
					memset(&OFN, 0x00, sizeof(OFN));
					memset(Filter, 0x00, sizeof(Filter));
					strcpy(Filter, "BMPt@C (*.bmp)");
					sPos = strlen(Filter);
					strcpy(&Filter[sPos+1], "*.bmp");
					OFN.lStructSize = sizeof(OPENFILENAME);
					OFN.hwndOwner = hWnd;
					OFN.hInstance = h_instdll;
					OFN.lpstrFilter = Filter;
					OFN.lpstrCustomFilter = NULL;
					OFN.nMaxCustFilter = 0;
					OFN.nFilterIndex = 0;
					OFN.lpstrFile = szCurDir;
					OFN.lpstrInitialDir = NULL;
					OFN.nMaxFile = sizeof(szCurDir);
					OFN.lpstrFileTitle = NULL;
					OFN.nMaxFileTitle = 0;
					OFN.lpstrTitle = "BMPt@C̑I";
					OFN.nFileOffset = 0;
					OFN.nFileExtension = 0;
					OFN.lpstrDefExt = NULL;
					OFN.lCustData = 0;
					OFN.lpfnHook = NULL;
					OFN.lpTemplateName = NULL;
					OFN.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
					if (GetOpenFileName(&OFN)) {
						SetDlgItemText(hWnd, IDC_EDIT1, OFN.lpstrFile);
						strcpy(szBMPFileName, OFN.lpstrFile);
						InvalidateRect(hWnd, NULL, TRUE);
					}
					/* _CAOLZꂽ牽Ȃ */
					break;

				case IDC_BUTTON2:	// ϊ
					memset(szBMPFileName, 0x00, sizeof(szBMPFileName));
					GetDlgItemText(hWnd, IDC_EDIT1, szBMPFileName, sizeof(szBMPFileName));
					if (strlen(szBMPFileName) == 0) {
						MessageBox(NULL, "BMPt@Cw肵ĂB", TITLE_LINE, MB_OK | MB_ICONSTOP);
						break;
					}
					if (IsDlgButtonChecked(hWnd, IDC_RADIOBUTTON1))
						bType = 0;
					else
						bType = 1;
					if (IsDlgButtonChecked(hWnd, IDC_RADIOBUTTON3))
						bRes = 0;
					else
						bRes = 1;
					if (bType == 0)
						OutputBMP(hWnd, szBMPFileName, bRes);
					else
						ReadBMP(hWnd, szBMPFileName, bRes);
					break;

				case IDC_BUTTON3:		// About...{^
					/* About̃_CAOo */
					DialogBox(h_instdll, "AboutBox", hWnd, (DLGPROC)About);
					break;

				case IDCANCEL:	// I{^
					EndDialog(hWnd, FALSE );
					return	TRUE;

			}
			break;
	}
	return (FALSE);
}

/////////////////////////////////////////////////////////////////////
// Board Information Service
/////////////////////////////////////////////////////////////////////
BOOL WINAPI
BoardInfomationService( 
	PEMUZ2000EBIH *info,
	DWORD id)
{

	*info = &emuz_1m11EBIH ;
	gId = id ;
	return	TRUE ;
}

/////////////////////////////////////////////////////////////////////
// Initialize Board
/////////////////////////////////////////////////////////////////////
BOOL WINAPI
IntializeBoard( 
	VOID)
{
	// |[gԍݒ
/*
	dwBase = emuz2000_readProfileDword( gId, "BaseAddress" ) ;
	switch( dwBase )
	{
	case	0x80:
		break ;
	default:
		dwBase = 0x80 ;
		break ;
	}
	// I/O |[gAhX擾
	emuz_1m11EBIH.ioMapper.ucStartPort = (UCHAR)dwBase ;
*/
	/* C̃AhX擾 */
	emuz2000_getGraphicRamPointers(gId, &cpGram1, &cpGram2, &cpGram3);
	return	TRUE ;
}

/////////////////////////////////////////////////////////////////////
// ReInitialize Board
/////////////////////////////////////////////////////////////////////
BOOL WINAPI
ReIntializeBoard( 
	VOID)
{
	return	TRUE ;
}

/////////////////////////////////////////////////////////////////////
// Finalize Board
/////////////////////////////////////////////////////////////////////
VOID WINAPI
FinalizeBoard( 
	VOID)
{
/*
	emuz2000_writeProfileDword( gId, "BaseAddress", dwBase ) ;
*/
	return ;
}

/////////////////////////////////////////////////////////////////////
// Report CPU Clock
/////////////////////////////////////////////////////////////////////
VOID WINAPI
ReportCpuClock( 
	int clk)
{
	return ;
}

/////////////////////////////////////////////////////////////////////
// Information Dialog
/////////////////////////////////////////////////////////////////////
VOID WINAPI
InfomationDialog( 
	HWND	hWnd)
{
	DialogBox( h_instdll, "MainDialog", hWnd, InfomationDlgProc);
	return ;
}

/////////////////////////////////////////////////////////////////////
// State Save Output
/////////////////////////////////////////////////////////////////////
#ifdef EMUZ2000EX
BOOL WINAPI
StateSaveOutputDataEx(
	int *ver,
	DWORD *size,
	PUCHAR *buf)
{
	*size = 0;
	*buf = NULL;
	*ver = 1;				/* Data Format Ver.1 */
	return TRUE;
}
#else
BOOL WINAPI
StateSaveOutputData( 
	DWORD *size,
	PUCHAR buf)
{
	*size = 0 ;
	buf = NULL ;
	return	TRUE ;
}
#endif

/////////////////////////////////////////////////////////////////////
// State Save Input
/////////////////////////////////////////////////////////////////////
#ifdef EMUZ2000EX
BOOL WINAPI
StateSaveInputDataEx(
	int ver,
	DWORD size,
	PUCHAR buf)
{
	return TRUE;
}
#else
BOOL WINAPI
StateSaveInputData( 
	DWORD size,
	PUCHAR buf)
{
	return	TRUE ;
}
#endif

/////////////////////////////////////////////////////////////////////
// Input Function Interface
/////////////////////////////////////////////////////////////////////
UCHAR
InportFunction(
	USHORT	port)
{
	UCHAR	data = 0 ;

	switch( port )
	{
	case	0x80:
		break ;
	}
	return	data ;
}

/////////////////////////////////////////////////////////////////////
// Output Function Interface
/////////////////////////////////////////////////////////////////////
int
OutportFunction(
	USHORT	port,
	UCHAR	data)
{
	switch( port )
	{
	case	0x80:
		break ;
	}

	return	0 ;
}
